{
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  Just one note, system hangs while component is active and you use reset (CTRL-F2)
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  --------------------------------
  Created by Gilles van den Hoven.
  --------------------------------
  E-mail: gilles@xpect.nl
   (or)
  E-mail: webmaster@ictivity.nl

}
unit AC;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  TAC = class(TComponent)
  private
    Old: HCursor;
    New: HCursor;
    FActive: Boolean;
    FFileName: String;
    procedure SetFileName(Value: String);
    procedure SetActive(Value: Boolean);
  published
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    property FN: String read FFilename write SetFileName;
    property Active: Boolean read FActive write SetActive;
  end;

procedure Register;

implementation
{$R AC.res}

procedure Register;
begin
  RegisterComponents('Win32', [TAC]);
end;

constructor TAC.Create(AOwner: TComponent);
begin
  FFilename := '';
  FActive := false;
  Old := GetCursor;
  Inherited Create(AOwner);
end;

Destructor TAC.Destroy;
begin
  SetActive(False);
end;

procedure TAC.SetFileName(Value: String);
begin
  If (FFilename<>Value) and FileExists(Value) then
  begin
    FFilename := Value;
    If (lowercase(ExtractFileExt(FFileName))='.cur') or (lowercase(ExtractFileExt(FFileName))='.ani') then
    begin
      New := LoadCursorFromFile(Pchar(FFileName));
      // Restore and set cursor to enable new filename settings...
      if FActive=True then
      begin
        SetActive(False);
        SetActive(True);
      end;
    end;
  end;
end;

procedure TAC.SetActive(Value: Boolean);
begin
    if Value<>FActive then
    begin
      FActive := Value;
      // Restore original cursor shape...
      if (FActive=False) then
      begin
        SetSystemCursor(Old, OCR_NORMAL);
      end;

      // Set new cursor shape...
      If FActive=True then
      begin
        Old := GetCursor;
        SetSystemCursor(New, OCR_NORMAL);
      end;
    end;
end;

end.
